%
% References :
%   -
%
% Author:  Jordan Caracotte, Fabio Morbidi and El Mustapha Mouaddib
% Date:    2020-04-15
% Version: 1.0
% Umail:   jordan.caracotte@etud.u-picardie.fr
% URL:     https://mis.u-picardie.fr/~fabio/PhotoSphere.html
%
% (c) 2020 Jordan Caracotte, Fabio Morbidi and El Mustapha Mouaddib, 
% MIS Laboratory, University of Picardie Jules Verne, Amiens, France
%
% History:
%   Date:       Version       Comment:
%   2020-04-15  1.0.20200415  Original Version
%

function [xs, ys, zs, x, y] = reverseProjection(m, n, camera_parameters)  
    [u, v] = meshgrid(1:m, 1:n);
    
    xi = camera_parameters.xi;
    ku = camera_parameters.ku;
    u0 = camera_parameters.u0;
    kv = camera_parameters.kv;
    v0 = camera_parameters.v0;
    
    l = xi;
    m = -(1+xi);
    
    x = ((u-1) - u0) / ku;
    y = ((v-1) - v0) / kv;
    
    xs = -(l.*x - (x.*(l.*(2.*l.*m - l.^2.*y.^2 - l.^2.*x.^2 + l.^2 + m.^2 + x.^2 + y.^2).^(1./2) + m.*(2.*l.*m - l.^2.*y.^2 - l.^2.*x.^2 + l.^2 + m.^2 + x.^2 + y.^2).^(1./2) + l.*x.^2 + l.*y.^2))./(2.*l.*m + l.^2 + m.^2 + x.^2 + y.^2))./(l + m);
    ys = -(l.*y - (y.*(l.*(2.*l.*m - l.^2.*y.^2 - l.^2.*x.^2 + l.^2 + m.^2 + x.^2 + y.^2).^(1./2) + m.*(2.*l.*m - l.^2.*y.^2 - l.^2.*x.^2 + l.^2 + m.^2 + x.^2 + y.^2).^(1./2) + l.*x.^2 + l.*y.^2))./(2.*l.*m + l.^2 + m.^2 + x.^2 + y.^2))./(l + m);
    zs = -(l.*(2.*l.*m - l.^2.*y.^2 - l.^2.*x.^2 + l.^2 + m.^2 + x.^2 + y.^2).^(1./2) + m.*(2.*l.*m - l.^2.*y.^2 - l.^2.*x.^2 + l.^2 + m.^2 + x.^2 + y.^2).^(1./2) + l.*x.^2 + l.*y.^2)./(2.*l.*m + l.^2 + m.^2 + x.^2 + y.^2);
end
